/* hypertextview.c generated by valac 0.28.0, the Vala compiler
 * generated from hypertextview.vala, do not modify */

/*
 *  Notes - panel plugin for Xfce Desktop Environment
 *  Copyright (c) 2009-2010  Mike Massonnet <mmassonnet@xfce.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gio/gio.h>


#define XNP_TYPE_HYPERTEXT_VIEW (xnp_hypertext_view_get_type ())
#define XNP_HYPERTEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView))
#define XNP_HYPERTEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextViewClass))
#define XNP_IS_HYPERTEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNP_TYPE_HYPERTEXT_VIEW))
#define XNP_IS_HYPERTEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNP_TYPE_HYPERTEXT_VIEW))
#define XNP_HYPERTEXT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextViewClass))

typedef struct _XnpHypertextView XnpHypertextView;
typedef struct _XnpHypertextViewClass XnpHypertextViewClass;
typedef struct _XnpHypertextViewPrivate XnpHypertextViewPrivate;
#define _gdk_cursor_unref0(var) ((var == NULL) ? NULL : (var = (gdk_cursor_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define __vala_PangoTabArray_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoTabArray_free (var), NULL)))

struct _XnpHypertextView {
	GtkTextView parent_instance;
	XnpHypertextViewPrivate * priv;
};

struct _XnpHypertextViewClass {
	GtkTextViewClass parent_class;
};

struct _XnpHypertextViewPrivate {
	GdkCursor* hand_cursor;
	GdkCursor* regular_cursor;
	gboolean cursor_over_link;
	guint undo_timeout;
	gint undo_cursor_pos;
	gchar* undo_text;
	gchar* redo_text;
	guint tag_timeout;
	GtkTextTag* tag_link;
	gchar* _font;
};


static gpointer xnp_hypertext_view_parent_class = NULL;

GType xnp_hypertext_view_get_type (void) G_GNUC_CONST;
#define XNP_HYPERTEXT_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextViewPrivate))
enum  {
	XNP_HYPERTEXT_VIEW_DUMMY_PROPERTY,
	XNP_HYPERTEXT_VIEW_FONT
};
XnpHypertextView* xnp_hypertext_view_new (void);
XnpHypertextView* xnp_hypertext_view_construct (GType object_type);
static gboolean xnp_hypertext_view_button_release_event_cb (XnpHypertextView* self, GtkWidget* hypertextview, GdkEventButton* event);
static gboolean _xnp_hypertext_view_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean xnp_hypertext_view_motion_notify_event_cb (XnpHypertextView* self, GtkWidget* hypertextview, GdkEventMotion* event);
static gboolean _xnp_hypertext_view_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static void xnp_hypertext_view_move_cursor_cb (XnpHypertextView* self, GtkWidget* hypertextview, GtkMovementStep step, gint count, gboolean extend_selection);
static void _xnp_hypertext_view_move_cursor_cb_gtk_text_view_move_cursor (GtkTextView* _sender, GtkMovementStep step, gint count, gboolean extend_selection, gpointer self);
static void xnp_hypertext_view_buffer_changed_cb (XnpHypertextView* self);
static void _xnp_hypertext_view_buffer_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender, gpointer self);
static void xnp_hypertext_view_insert_text_cb (XnpHypertextView* self, GtkTextBuffer* buffer, GtkTextIter* location, const gchar* text, gint len);
static void _xnp_hypertext_view_insert_text_cb_gtk_text_buffer_insert_text (GtkTextBuffer* _sender, GtkTextIter* pos, const gchar* text, gint length, gpointer self);
static void xnp_hypertext_view_delete_range_cb (XnpHypertextView* self, GtkTextBuffer* buffer, GtkTextIter* start, GtkTextIter* end);
static void _xnp_hypertext_view_delete_range_cb_gtk_text_buffer_delete_range (GtkTextBuffer* _sender, GtkTextIter* start, GtkTextIter* end, gpointer self);
static gboolean xnp_hypertext_view_undo_snapshot (XnpHypertextView* self);
void xnp_hypertext_view_update_tags (XnpHypertextView* self);
static gboolean _xnp_hypertext_view_undo_snapshot_gsource_func (gpointer self);
static gboolean xnp_hypertext_view_tag_timeout_cb (XnpHypertextView* self);
static gboolean _xnp_hypertext_view_tag_timeout_cb_gsource_func (gpointer self);
static void xnp_hypertext_view_tag_timeout_init (XnpHypertextView* self);
void xnp_hypertext_view_undo (XnpHypertextView* self);
const gchar* xnp_hypertext_view_get_font (XnpHypertextView* self);
void xnp_hypertext_view_set_font (XnpHypertextView* self, const gchar* value);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static GObject * xnp_hypertext_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _vala_PangoTabArray_free (PangoTabArray* self);
static void xnp_hypertext_view_finalize (GObject* obj);
static void _vala_xnp_hypertext_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_xnp_hypertext_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gboolean _xnp_hypertext_view_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = xnp_hypertext_view_button_release_event_cb ((XnpHypertextView*) self, _sender, event);
	return result;
}


static gboolean _xnp_hypertext_view_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = xnp_hypertext_view_motion_notify_event_cb ((XnpHypertextView*) self, _sender, event);
	return result;
}


static void _xnp_hypertext_view_move_cursor_cb_gtk_text_view_move_cursor (GtkTextView* _sender, GtkMovementStep step, gint count, gboolean extend_selection, gpointer self) {
	xnp_hypertext_view_move_cursor_cb ((XnpHypertextView*) self, _sender, step, count, extend_selection);
}


static void _xnp_hypertext_view_buffer_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender, gpointer self) {
	xnp_hypertext_view_buffer_changed_cb ((XnpHypertextView*) self);
}


static void _xnp_hypertext_view_insert_text_cb_gtk_text_buffer_insert_text (GtkTextBuffer* _sender, GtkTextIter* pos, const gchar* text, gint length, gpointer self) {
	xnp_hypertext_view_insert_text_cb ((XnpHypertextView*) self, _sender, pos, text, length);
}


static void _xnp_hypertext_view_delete_range_cb_gtk_text_buffer_delete_range (GtkTextBuffer* _sender, GtkTextIter* start, GtkTextIter* end, gpointer self) {
	xnp_hypertext_view_delete_range_cb ((XnpHypertextView*) self, _sender, start, end);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


XnpHypertextView* xnp_hypertext_view_construct (GType object_type) {
	XnpHypertextView * self = NULL;
	GtkTextIter iter = {0};
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	GtkTextBuffer* _tmp2_ = NULL;
	GtkTextBuffer* _tmp3_ = NULL;
	GtkTextBuffer* _tmp4_ = NULL;
	GtkTextBuffer* _tmp5_ = NULL;
	GtkTextBuffer* _tmp6_ = NULL;
	GtkTextBuffer* _tmp7_ = NULL;
	GtkTextIter _tmp8_ = {0};
	GtkTextBuffer* _tmp9_ = NULL;
	GtkTextBuffer* _tmp10_ = NULL;
	GtkTextIter _tmp11_ = {0};
	GtkTextBuffer* _tmp12_ = NULL;
	GtkTextBuffer* _tmp13_ = NULL;
	GtkTextTag* _tmp14_ = NULL;
	GtkTextTag* _tmp15_ = NULL;
	self = (XnpHypertextView*) g_object_new (object_type, NULL);
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _xnp_hypertext_view_button_release_event_cb_gtk_widget_button_release_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _xnp_hypertext_view_motion_notify_event_cb_gtk_widget_motion_notify_event, self, 0);
	g_signal_connect_object ((GtkTextView*) self, "move-cursor", (GCallback) _xnp_hypertext_view_move_cursor_cb_gtk_text_view_move_cursor, self, 0);
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp1_ = _tmp0_;
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _xnp_hypertext_view_buffer_changed_cb_gtk_text_buffer_changed, self, 0);
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp3_ = _tmp2_;
	g_signal_connect_object (_tmp3_, "insert-text", (GCallback) _xnp_hypertext_view_insert_text_cb_gtk_text_buffer_insert_text, self, 0);
	_tmp4_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp5_ = _tmp4_;
	g_signal_connect_object (_tmp5_, "delete-range", (GCallback) _xnp_hypertext_view_delete_range_cb_gtk_text_buffer_delete_range, self, 0);
	_tmp6_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp7_ = _tmp6_;
	gtk_text_buffer_get_iter_at_offset (_tmp7_, &_tmp8_, 0);
	iter = _tmp8_;
	_tmp9_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp10_ = _tmp9_;
	_tmp11_ = iter;
	gtk_text_buffer_create_mark (_tmp10_, "undo-pos", &_tmp11_, FALSE);
	_tmp12_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp13_ = _tmp12_;
	_tmp14_ = gtk_text_buffer_create_tag (_tmp13_, "link", "foreground", "blue", "underline", PANGO_UNDERLINE_SINGLE, NULL, NULL);
	_tmp15_ = _g_object_ref0 (_tmp14_);
	_g_object_unref0 (self->priv->tag_link);
	self->priv->tag_link = _tmp15_;
	return self;
}


XnpHypertextView* xnp_hypertext_view_new (void) {
	return xnp_hypertext_view_construct (XNP_TYPE_HYPERTEXT_VIEW);
}


/**
 * button_release_event_cb:
 *
 * Event to open links.
 */
static gboolean xnp_hypertext_view_button_release_event_cb (XnpHypertextView* self, GtkWidget* hypertextview, GdkEventButton* event) {
	gboolean result = FALSE;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextIter iter = {0};
	gchar* link = NULL;
	gint x = 0;
	gint y = 0;
	GdkEventButton _tmp0_ = {0};
	guint _tmp1_ = 0U;
	GtkTextBuffer* _tmp2_ = NULL;
	GtkTextBuffer* _tmp3_ = NULL;
	GtkTextIter _tmp4_ = {0};
	GtkTextIter _tmp5_ = {0};
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GdkEventButton _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	GdkEventButton _tmp10_ = {0};
	gdouble _tmp11_ = 0.0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	GtkTextIter _tmp16_ = {0};
	GtkTextTag* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (hypertextview != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = *event;
	_tmp1_ = _tmp0_.button;
	if (_tmp1_ != ((guint) 1)) {
		result = FALSE;
		_g_free0 (link);
		return result;
	}
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp3_ = _tmp2_;
	gtk_text_buffer_get_selection_bounds (_tmp3_, &_tmp4_, &_tmp5_);
	start = _tmp4_;
	end = _tmp5_;
	_tmp6_ = gtk_text_iter_get_offset (&start);
	_tmp7_ = gtk_text_iter_get_offset (&end);
	if (_tmp6_ != _tmp7_) {
		result = FALSE;
		_g_free0 (link);
		return result;
	}
	_tmp8_ = *event;
	_tmp9_ = _tmp8_.x;
	_tmp10_ = *event;
	_tmp11_ = _tmp10_.y;
	gtk_text_view_window_to_buffer_coords ((GtkTextView*) self, GTK_TEXT_WINDOW_WIDGET, (gint) _tmp9_, (gint) _tmp11_, &_tmp12_, &_tmp13_);
	x = _tmp12_;
	y = _tmp13_;
	_tmp14_ = x;
	_tmp15_ = y;
	gtk_text_view_get_iter_at_location ((GtkTextView*) self, &_tmp16_, _tmp14_, _tmp15_);
	iter = _tmp16_;
	_tmp17_ = self->priv->tag_link;
	_tmp18_ = gtk_text_iter_has_tag (&iter, _tmp17_);
	if (_tmp18_) {
		GtkTextIter _tmp19_ = {0};
		GtkTextIter _tmp20_ = {0};
		GtkTextTag* _tmp21_ = NULL;
		gboolean _tmp22_ = FALSE;
		GtkTextTag* _tmp24_ = NULL;
		GtkTextIter _tmp25_ = {0};
		gchar* _tmp26_ = NULL;
		_tmp19_ = iter;
		end = _tmp19_;
		_tmp20_ = end;
		start = _tmp20_;
		_tmp21_ = self->priv->tag_link;
		_tmp22_ = gtk_text_iter_begins_tag (&start, _tmp21_);
		if (!_tmp22_) {
			GtkTextTag* _tmp23_ = NULL;
			_tmp23_ = self->priv->tag_link;
			gtk_text_iter_backward_to_tag_toggle (&start, _tmp23_);
		}
		_tmp24_ = self->priv->tag_link;
		gtk_text_iter_forward_to_tag_toggle (&end, _tmp24_);
		_tmp25_ = end;
		_tmp26_ = gtk_text_iter_get_text (&start, &_tmp25_);
		_g_free0 (link);
		link = _tmp26_;
		{
			const gchar* _tmp27_ = NULL;
			gchar* _tmp28_ = NULL;
			gchar* _tmp29_ = NULL;
			_tmp27_ = link;
			_tmp28_ = g_strconcat ("exo-open ", _tmp27_, NULL);
			_tmp29_ = _tmp28_;
			g_spawn_command_line_async (_tmp29_, &_inner_error_);
			_g_free0 (_tmp29_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch16_g_error;
			}
			result = FALSE;
			_g_free0 (link);
			return result;
		}
		goto __finally16;
		__catch16_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally16:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (link);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		{
			const gchar* _tmp30_ = NULL;
			_tmp30_ = link;
			g_app_info_launch_default_for_uri (_tmp30_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch17_g_error;
			}
			result = FALSE;
			_g_free0 (link);
			return result;
		}
		goto __finally17;
		__catch17_g_error:
		{
			GError* e = NULL;
			GError* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp31_ = e;
			_tmp32_ = _tmp31_->message;
			g_message ("hypertextview.vala:127: Unable to open link with default handler: %s", _tmp32_);
			_g_error_free0 (e);
		}
		__finally17:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (link);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		{
			const gchar* _tmp33_ = NULL;
			gchar* _tmp34_ = NULL;
			gchar* _tmp35_ = NULL;
			_tmp33_ = link;
			_tmp34_ = g_strconcat ("xdg-open ", _tmp33_, NULL);
			_tmp35_ = _tmp34_;
			g_spawn_command_line_async (_tmp35_, &_inner_error_);
			_g_free0 (_tmp35_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch18_g_error;
			}
			result = FALSE;
			_g_free0 (link);
			return result;
		}
		goto __finally18;
		__catch18_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally18:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (link);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		{
			const gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			_tmp36_ = link;
			_tmp37_ = g_strconcat ("firefox ", _tmp36_, NULL);
			_tmp38_ = _tmp37_;
			g_spawn_command_line_async (_tmp38_, &_inner_error_);
			_g_free0 (_tmp38_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch19_g_error;
			}
			result = FALSE;
			_g_free0 (link);
			return result;
		}
		goto __finally19;
		__catch19_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally19:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (link);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		g_message ("hypertextview.vala:142: Unable to find an appropriate fallback to open" \
" the link");
	}
	result = FALSE;
	_g_free0 (link);
	return result;
}


/**
 * motion_notify_event_cb:
 *
 * Event to update the cursor of the pointer.
 */
static gboolean xnp_hypertext_view_motion_notify_event_cb (XnpHypertextView* self, GtkWidget* hypertextview, GdkEventMotion* event) {
	gboolean result = FALSE;
	GtkTextIter iter = {0};
	GdkWindow* win = NULL;
	gboolean over_link = FALSE;
	gint x = 0;
	gint y = 0;
	GdkEventMotion _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	GdkEventMotion _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GtkTextIter _tmp8_ = {0};
	GtkTextTag* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (hypertextview != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = *event;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = *event;
	_tmp3_ = _tmp2_.y;
	gtk_text_view_window_to_buffer_coords ((GtkTextView*) self, GTK_TEXT_WINDOW_WIDGET, (gint) _tmp1_, (gint) _tmp3_, &_tmp4_, &_tmp5_);
	x = _tmp4_;
	y = _tmp5_;
	_tmp6_ = x;
	_tmp7_ = y;
	gtk_text_view_get_iter_at_location ((GtkTextView*) self, &_tmp8_, _tmp6_, _tmp7_);
	iter = _tmp8_;
	_tmp9_ = self->priv->tag_link;
	_tmp10_ = gtk_text_iter_has_tag (&iter, _tmp9_);
	over_link = _tmp10_;
	_tmp11_ = over_link;
	_tmp12_ = self->priv->cursor_over_link;
	if (_tmp11_ != _tmp12_) {
		gboolean _tmp13_ = FALSE;
		GdkWindow* _tmp14_ = NULL;
		GdkWindow* _tmp15_ = NULL;
		GdkCursor* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
		GdkWindow* _tmp20_ = NULL;
		_tmp13_ = over_link;
		self->priv->cursor_over_link = _tmp13_;
		_tmp14_ = gtk_text_view_get_window ((GtkTextView*) self, GTK_TEXT_WINDOW_TEXT);
		_tmp15_ = _g_object_ref0 (_tmp14_);
		_g_object_unref0 (win);
		win = _tmp15_;
		_tmp17_ = over_link;
		if (_tmp17_) {
			GdkCursor* _tmp18_ = NULL;
			_tmp18_ = self->priv->hand_cursor;
			_tmp16_ = _tmp18_;
		} else {
			GdkCursor* _tmp19_ = NULL;
			_tmp19_ = self->priv->regular_cursor;
			_tmp16_ = _tmp19_;
		}
		_tmp20_ = win;
		gdk_window_set_cursor (_tmp20_, _tmp16_);
	}
	result = FALSE;
	_g_object_unref0 (win);
	return result;
}


/**
 * move_cursor_cb:
 *
 * Destroys existing timeouts and executes the actions immediately.
 */
static void xnp_hypertext_view_move_cursor_cb (XnpHypertextView* self, GtkWidget* hypertextview, GtkMovementStep step, gint count, gboolean extend_selection) {
	guint _tmp0_ = 0U;
	guint _tmp6_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (hypertextview != NULL);
	_tmp0_ = self->priv->undo_timeout;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_ = 0U;
		GtkTextBuffer* _tmp2_ = NULL;
		GtkTextBuffer* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		_tmp1_ = self->priv->undo_timeout;
		g_source_remove (_tmp1_);
		self->priv->undo_timeout = (guint) 0;
		xnp_hypertext_view_undo_snapshot (self);
		_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
		_tmp3_ = _tmp2_;
		g_object_get (_tmp3_, "cursor-position", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		self->priv->undo_cursor_pos = _tmp5_;
	}
	_tmp6_ = self->priv->tag_timeout;
	if (_tmp6_ > ((guint) 0)) {
		guint _tmp7_ = 0U;
		_tmp7_ = self->priv->tag_timeout;
		g_source_remove (_tmp7_);
		self->priv->tag_timeout = (guint) 0;
		xnp_hypertext_view_update_tags (self);
	}
}


/**
 * buffer_changed_cb:
 *
 * Initializes timeouts to postpone actions.
 */
static gboolean _xnp_hypertext_view_undo_snapshot_gsource_func (gpointer self) {
	gboolean result;
	result = xnp_hypertext_view_undo_snapshot ((XnpHypertextView*) self);
	return result;
}


static gboolean _xnp_hypertext_view_tag_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = xnp_hypertext_view_tag_timeout_cb ((XnpHypertextView*) self);
	return result;
}


static void xnp_hypertext_view_buffer_changed_cb (XnpHypertextView* self) {
	guint _tmp0_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undo_timeout;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->undo_timeout;
		g_source_remove (_tmp1_);
		self->priv->undo_timeout = (guint) 0;
	}
	_tmp2_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _xnp_hypertext_view_undo_snapshot_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->undo_timeout = _tmp2_;
	_tmp3_ = self->priv->tag_timeout;
	if (_tmp3_ > ((guint) 0)) {
		guint _tmp4_ = 0U;
		guint _tmp5_ = 0U;
		_tmp4_ = self->priv->tag_timeout;
		g_source_remove (_tmp4_);
		self->priv->tag_timeout = (guint) 0;
		_tmp5_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _xnp_hypertext_view_tag_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->tag_timeout = _tmp5_;
	}
}


/**
 * insert_text_cb:
 *
 * Event to create and update existing tags within the buffer.
 */
static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static void xnp_hypertext_view_insert_text_cb (XnpHypertextView* self, GtkTextBuffer* buffer, GtkTextIter* location, const gchar* text, gint len) {
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	gboolean _tmp0_ = FALSE;
	GtkTextTag* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (buffer != NULL);
	g_return_if_fail (location != NULL);
	g_return_if_fail (text != NULL);
	_tmp1_ = self->priv->tag_link;
	_tmp2_ = gtk_text_iter_has_tag (location, _tmp1_);
	if (_tmp2_) {
		GtkTextTag* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		_tmp3_ = self->priv->tag_link;
		_tmp4_ = gtk_text_iter_begins_tag (location, _tmp3_);
		_tmp0_ = !_tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkTextIter _tmp5_ = {0};
		GtkTextTag* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		_tmp5_ = *location;
		start = _tmp5_;
		_tmp6_ = self->priv->tag_link;
		gtk_text_iter_backward_to_tag_toggle (&start, _tmp6_);
		_tmp7_ = gtk_text_iter_get_offset (location);
		_tmp8_ = gtk_text_iter_get_offset (&start);
		if ((_tmp7_ - _tmp8_) < 7) {
			GtkTextIter _tmp9_ = {0};
			GtkTextTag* _tmp10_ = NULL;
			GtkTextBuffer* _tmp11_ = NULL;
			GtkTextBuffer* _tmp12_ = NULL;
			GtkTextTag* _tmp13_ = NULL;
			GtkTextIter _tmp14_ = {0};
			GtkTextIter _tmp15_ = {0};
			gboolean _tmp16_ = FALSE;
			gint _tmp17_ = 0;
			_tmp9_ = start;
			end = _tmp9_;
			_tmp10_ = self->priv->tag_link;
			gtk_text_iter_forward_to_tag_toggle (&end, _tmp10_);
			_tmp11_ = gtk_text_view_get_buffer ((GtkTextView*) self);
			_tmp12_ = _tmp11_;
			_tmp13_ = self->priv->tag_link;
			_tmp14_ = start;
			_tmp15_ = end;
			gtk_text_buffer_remove_tag (_tmp12_, _tmp13_, &_tmp14_, &_tmp15_);
			_tmp17_ = len;
			if (_tmp17_ > 1) {
				gboolean _tmp18_ = FALSE;
				const gchar* _tmp19_ = NULL;
				gboolean _tmp20_ = FALSE;
				_tmp19_ = text;
				_tmp20_ = string_contains (_tmp19_, " ");
				if (_tmp20_) {
					_tmp18_ = TRUE;
				} else {
					const gchar* _tmp21_ = NULL;
					gboolean _tmp22_ = FALSE;
					_tmp21_ = text;
					_tmp22_ = string_contains (_tmp21_, "\n");
					_tmp18_ = _tmp22_;
				}
				_tmp16_ = _tmp18_;
			} else {
				_tmp16_ = FALSE;
			}
			if (_tmp16_) {
				xnp_hypertext_view_tag_timeout_init (self);
			}
		} else {
			gboolean _tmp23_ = FALSE;
			const gchar* _tmp24_ = NULL;
			gboolean _tmp25_ = FALSE;
			_tmp24_ = text;
			_tmp25_ = string_contains (_tmp24_, " ");
			if (_tmp25_) {
				_tmp23_ = TRUE;
			} else {
				const gchar* _tmp26_ = NULL;
				gboolean _tmp27_ = FALSE;
				_tmp26_ = text;
				_tmp27_ = string_contains (_tmp26_, "\n");
				_tmp23_ = _tmp27_;
			}
			if (_tmp23_) {
				GtkTextIter _tmp28_ = {0};
				GtkTextTag* _tmp29_ = NULL;
				GtkTextBuffer* _tmp30_ = NULL;
				GtkTextBuffer* _tmp31_ = NULL;
				GtkTextTag* _tmp32_ = NULL;
				GtkTextIter _tmp33_ = {0};
				GtkTextIter _tmp34_ = {0};
				_tmp28_ = *location;
				end = _tmp28_;
				_tmp29_ = self->priv->tag_link;
				gtk_text_iter_forward_to_tag_toggle (&end, _tmp29_);
				_tmp30_ = gtk_text_view_get_buffer ((GtkTextView*) self);
				_tmp31_ = _tmp30_;
				_tmp32_ = self->priv->tag_link;
				_tmp33_ = start;
				_tmp34_ = end;
				gtk_text_buffer_remove_tag (_tmp31_, _tmp32_, &_tmp33_, &_tmp34_);
				xnp_hypertext_view_tag_timeout_init (self);
			}
		}
	} else {
		GtkTextTag* _tmp35_ = NULL;
		gboolean _tmp36_ = FALSE;
		_tmp35_ = self->priv->tag_link;
		_tmp36_ = gtk_text_iter_ends_tag (location, _tmp35_);
		if (_tmp36_) {
			gboolean _tmp37_ = FALSE;
			gint _tmp38_ = 0;
			_tmp38_ = len;
			if (_tmp38_ >= 1) {
				gboolean _tmp39_ = FALSE;
				const gchar* _tmp40_ = NULL;
				gchar _tmp41_ = '\0';
				_tmp40_ = text;
				_tmp41_ = string_get (_tmp40_, (glong) 0);
				if (_tmp41_ == ' ') {
					_tmp39_ = TRUE;
				} else {
					const gchar* _tmp42_ = NULL;
					gchar _tmp43_ = '\0';
					_tmp42_ = text;
					_tmp43_ = string_get (_tmp42_, (glong) 0);
					_tmp39_ = _tmp43_ == '\n';
				}
				_tmp37_ = !_tmp39_;
			} else {
				_tmp37_ = FALSE;
			}
			if (_tmp37_) {
				GtkTextIter _tmp44_ = {0};
				GtkTextTag* _tmp45_ = NULL;
				GtkTextBuffer* _tmp46_ = NULL;
				GtkTextBuffer* _tmp47_ = NULL;
				GtkTextTag* _tmp48_ = NULL;
				GtkTextIter _tmp49_ = {0};
				GtkTextIter _tmp50_ = {0};
				_tmp44_ = *location;
				start = _tmp44_;
				_tmp45_ = self->priv->tag_link;
				gtk_text_iter_backward_to_tag_toggle (&start, _tmp45_);
				_tmp46_ = gtk_text_view_get_buffer ((GtkTextView*) self);
				_tmp47_ = _tmp46_;
				_tmp48_ = self->priv->tag_link;
				_tmp49_ = start;
				_tmp50_ = *location;
				gtk_text_buffer_remove_tag (_tmp47_, _tmp48_, &_tmp49_, &_tmp50_);
				xnp_hypertext_view_tag_timeout_init (self);
			}
		} else {
			gboolean _tmp51_ = FALSE;
			gint _tmp52_ = 0;
			_tmp52_ = len;
			if (_tmp52_ == 1) {
				const gchar* _tmp53_ = NULL;
				gchar _tmp54_ = '\0';
				_tmp53_ = text;
				_tmp54_ = string_get (_tmp53_, (glong) 0);
				_tmp51_ = _tmp54_ == '/';
			} else {
				_tmp51_ = FALSE;
			}
			if (_tmp51_) {
				GtkTextIter _tmp55_ = {0};
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
				_tmp55_ = *location;
				start = _tmp55_;
				_tmp57_ = gtk_text_iter_backward_chars (&start, 6);
				if (!_tmp57_) {
					_tmp56_ = TRUE;
				} else {
					GtkTextIter _tmp58_ = {0};
					gchar* _tmp59_ = NULL;
					gchar* _tmp60_ = NULL;
					gchar* _tmp61_ = NULL;
					gchar* _tmp62_ = NULL;
					_tmp58_ = *location;
					_tmp59_ = gtk_text_iter_get_text (&start, &_tmp58_);
					_tmp60_ = _tmp59_;
					_tmp61_ = g_utf8_strdown (_tmp60_, (gssize) (-1));
					_tmp62_ = _tmp61_;
					_tmp56_ = g_strcmp0 (_tmp62_, "http:/") != 0;
					_g_free0 (_tmp62_);
					_g_free0 (_tmp60_);
				}
				if (_tmp56_) {
					return;
				}
				xnp_hypertext_view_tag_timeout_init (self);
			} else {
				gboolean _tmp63_ = FALSE;
				gint _tmp64_ = 0;
				_tmp64_ = len;
				if (_tmp64_ == 1) {
					gboolean _tmp65_ = FALSE;
					const gchar* _tmp66_ = NULL;
					gchar _tmp67_ = '\0';
					_tmp66_ = text;
					_tmp67_ = string_get (_tmp66_, (glong) 0);
					if (_tmp67_ == ' ') {
						_tmp65_ = TRUE;
					} else {
						const gchar* _tmp68_ = NULL;
						gchar _tmp69_ = '\0';
						_tmp68_ = text;
						_tmp69_ = string_get (_tmp68_, (glong) 0);
						_tmp65_ = _tmp69_ == '\n';
					}
					_tmp63_ = _tmp65_;
				} else {
					_tmp63_ = FALSE;
				}
				if (_tmp63_) {
					xnp_hypertext_view_update_tags (self);
				} else {
					gboolean _tmp70_ = FALSE;
					gint _tmp71_ = 0;
					_tmp71_ = len;
					if (_tmp71_ > 1) {
						const gchar* _tmp72_ = NULL;
						gboolean _tmp73_ = FALSE;
						_tmp72_ = text;
						_tmp73_ = string_contains (_tmp72_, "http://");
						_tmp70_ = _tmp73_;
					} else {
						_tmp70_ = FALSE;
					}
					if (_tmp70_) {
						xnp_hypertext_view_tag_timeout_init (self);
					}
				}
			}
		}
	}
}


/**
 * delete_range_cb:
 *
 * Event to delete and update existing tags within the buffer.
 */
static void xnp_hypertext_view_delete_range_cb (XnpHypertextView* self, GtkTextBuffer* buffer, GtkTextIter* start, GtkTextIter* end) {
	GtkTextIter iter = {0};
	gboolean _tmp0_ = FALSE;
	GtkTextTag* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GtkTextTag* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GtkTextTag* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (buffer != NULL);
	g_return_if_fail (start != NULL);
	g_return_if_fail (end != NULL);
	_tmp1_ = self->priv->tag_link;
	_tmp2_ = gtk_text_iter_has_tag (start, _tmp1_);
	if (!_tmp2_) {
		GtkTextTag* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		_tmp3_ = self->priv->tag_link;
		_tmp4_ = gtk_text_iter_has_tag (end, _tmp3_);
		_tmp0_ = !_tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp5_ = self->priv->tag_link;
	_tmp6_ = gtk_text_iter_has_tag (start, _tmp5_);
	if (_tmp6_) {
		GtkTextIter _tmp7_ = {0};
		GtkTextTag* _tmp8_ = NULL;
		GtkTextBuffer* _tmp9_ = NULL;
		GtkTextBuffer* _tmp10_ = NULL;
		GtkTextTag* _tmp11_ = NULL;
		GtkTextIter _tmp12_ = {0};
		GtkTextIter _tmp13_ = {0};
		_tmp7_ = *start;
		iter = _tmp7_;
		_tmp8_ = self->priv->tag_link;
		gtk_text_iter_backward_to_tag_toggle (&iter, _tmp8_);
		_tmp9_ = gtk_text_view_get_buffer ((GtkTextView*) self);
		_tmp10_ = _tmp9_;
		_tmp11_ = self->priv->tag_link;
		_tmp12_ = iter;
		_tmp13_ = *start;
		gtk_text_buffer_remove_tag (_tmp10_, _tmp11_, &_tmp12_, &_tmp13_);
	}
	_tmp14_ = self->priv->tag_link;
	_tmp15_ = gtk_text_iter_has_tag (end, _tmp14_);
	if (_tmp15_) {
		GtkTextIter _tmp16_ = {0};
		GtkTextTag* _tmp17_ = NULL;
		GtkTextBuffer* _tmp18_ = NULL;
		GtkTextBuffer* _tmp19_ = NULL;
		GtkTextTag* _tmp20_ = NULL;
		GtkTextIter _tmp21_ = {0};
		GtkTextIter _tmp22_ = {0};
		_tmp16_ = *end;
		iter = _tmp16_;
		_tmp17_ = self->priv->tag_link;
		gtk_text_iter_forward_to_tag_toggle (&iter, _tmp17_);
		_tmp18_ = gtk_text_view_get_buffer ((GtkTextView*) self);
		_tmp19_ = _tmp18_;
		_tmp20_ = self->priv->tag_link;
		_tmp21_ = *end;
		_tmp22_ = iter;
		gtk_text_buffer_remove_tag (_tmp19_, _tmp20_, &_tmp21_, &_tmp22_);
	}
	xnp_hypertext_view_tag_timeout_init (self);
}


/**
 * undo_snapshot:
 *
 * Makes a snapshot of the current buffer and swaps undo/redo texts.
 */
static gboolean xnp_hypertext_view_undo_snapshot (XnpHypertextView* self) {
	gboolean result = FALSE;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GtkTextBuffer* _tmp4_ = NULL;
	GtkTextBuffer* _tmp5_ = NULL;
	GtkTextIter _tmp6_ = {0};
	GtkTextBuffer* _tmp7_ = NULL;
	GtkTextBuffer* _tmp8_ = NULL;
	GtkTextIter _tmp9_ = {0};
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	GtkTextBuffer* _tmp12_ = NULL;
	GtkTextBuffer* _tmp13_ = NULL;
	GtkTextIter _tmp14_ = {0};
	GtkTextIter _tmp15_ = {0};
	gchar* _tmp16_ = NULL;
	guint _tmp17_ = 0U;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp1_ = _tmp0_;
	g_object_get (_tmp1_, "cursor-position", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	self->priv->undo_cursor_pos = _tmp3_;
	_tmp4_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp5_ = _tmp4_;
	gtk_text_buffer_get_iter_at_offset (_tmp5_, &_tmp6_, 0);
	start = _tmp6_;
	_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp8_ = _tmp7_;
	gtk_text_buffer_get_iter_at_offset (_tmp8_, &_tmp9_, -1);
	end = _tmp9_;
	_tmp10_ = self->priv->redo_text;
	_tmp11_ = g_strdup (_tmp10_);
	_g_free0 (self->priv->undo_text);
	self->priv->undo_text = _tmp11_;
	_tmp12_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp13_ = _tmp12_;
	_tmp14_ = start;
	_tmp15_ = end;
	_tmp16_ = gtk_text_buffer_get_text (_tmp13_, &_tmp14_, &_tmp15_, FALSE);
	_g_free0 (self->priv->redo_text);
	self->priv->redo_text = _tmp16_;
	_tmp17_ = self->priv->undo_timeout;
	if (_tmp17_ > ((guint) 0)) {
		guint _tmp18_ = 0U;
		_tmp18_ = self->priv->undo_timeout;
		g_source_remove (_tmp18_);
		self->priv->undo_timeout = (guint) 0;
	}
	result = FALSE;
	return result;
}


/**
 * undo:
 *
 * Revert the buffer to the undo text and swaps undo/redo texts.
 */
void xnp_hypertext_view_undo (XnpHypertextView* self) {
	GtkTextIter iter = {0};
	GtkTextMark* mark = NULL;
	gchar* tmp = NULL;
	guint _tmp0_ = 0U;
	GtkTextBuffer* _tmp2_ = NULL;
	GtkTextBuffer* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GtkTextBuffer* _tmp5_ = NULL;
	GtkTextBuffer* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	GtkTextIter _tmp8_ = {0};
	GtkTextBuffer* _tmp9_ = NULL;
	GtkTextBuffer* _tmp10_ = NULL;
	GtkTextIter _tmp11_ = {0};
	GtkTextBuffer* _tmp12_ = NULL;
	GtkTextBuffer* _tmp13_ = NULL;
	GtkTextMark* _tmp14_ = NULL;
	GtkTextMark* _tmp15_ = NULL;
	GtkTextBuffer* _tmp16_ = NULL;
	GtkTextBuffer* _tmp17_ = NULL;
	GtkTextMark* _tmp18_ = NULL;
	GtkTextIter _tmp19_ = {0};
	GtkTextMark* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	guint _tmp27_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undo_timeout;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->undo_timeout;
		g_source_remove (_tmp1_);
		self->priv->undo_timeout = (guint) 0;
		xnp_hypertext_view_undo_snapshot (self);
	}
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->undo_text;
	gtk_text_buffer_set_text (_tmp3_, _tmp4_, -1);
	_tmp5_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->undo_cursor_pos;
	gtk_text_buffer_get_iter_at_offset (_tmp6_, &_tmp8_, _tmp7_);
	iter = _tmp8_;
	_tmp9_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp10_ = _tmp9_;
	_tmp11_ = iter;
	gtk_text_buffer_place_cursor (_tmp10_, &_tmp11_);
	_tmp12_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp13_ = _tmp12_;
	_tmp14_ = gtk_text_buffer_get_mark (_tmp13_, "undo-pos");
	_tmp15_ = _g_object_ref0 (_tmp14_);
	_g_object_unref0 (mark);
	mark = _tmp15_;
	_tmp16_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp17_ = _tmp16_;
	_tmp18_ = mark;
	_tmp19_ = iter;
	gtk_text_buffer_move_mark (_tmp17_, _tmp18_, &_tmp19_);
	_tmp20_ = mark;
	gtk_text_view_scroll_to_mark ((GtkTextView*) self, _tmp20_, 0.0, FALSE, 0.5, 0.5);
	_tmp21_ = self->priv->undo_text;
	_tmp22_ = g_strdup (_tmp21_);
	_g_free0 (tmp);
	tmp = _tmp22_;
	_tmp23_ = self->priv->redo_text;
	_tmp24_ = g_strdup (_tmp23_);
	_g_free0 (self->priv->undo_text);
	self->priv->undo_text = _tmp24_;
	_tmp25_ = tmp;
	_tmp26_ = g_strdup (_tmp25_);
	_g_free0 (self->priv->redo_text);
	self->priv->redo_text = _tmp26_;
	_tmp27_ = self->priv->undo_timeout;
	if (_tmp27_ > ((guint) 0)) {
		guint _tmp28_ = 0U;
		_tmp28_ = self->priv->undo_timeout;
		g_source_remove (_tmp28_);
		self->priv->undo_timeout = (guint) 0;
	}
	_g_free0 (tmp);
	_g_object_unref0 (mark);
}


static gboolean xnp_hypertext_view_tag_timeout_cb (XnpHypertextView* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	xnp_hypertext_view_update_tags (self);
	result = FALSE;
	return result;
}


static void xnp_hypertext_view_tag_timeout_init (XnpHypertextView* self) {
	guint _tmp0_ = 0U;
	guint _tmp2_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tag_timeout;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->tag_timeout;
		g_source_remove (_tmp1_);
		self->priv->tag_timeout = (guint) 0;
	}
	_tmp2_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _xnp_hypertext_view_tag_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->tag_timeout = _tmp2_;
}


/**
 * update_tags:
 *
 * Goes through the entire document to search for untagged HTTP links and tag them.
 */
void xnp_hypertext_view_update_tags (XnpHypertextView* self) {
	GtkTextIter iter = {0};
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextIter tmp = {0};
	guint _tmp0_ = 0U;
	GtkTextBuffer* _tmp2_ = NULL;
	GtkTextBuffer* _tmp3_ = NULL;
	GtkTextIter _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tag_timeout;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->tag_timeout;
		g_source_remove (_tmp1_);
		self->priv->tag_timeout = (guint) 0;
	}
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp3_ = _tmp2_;
	gtk_text_buffer_get_iter_at_offset (_tmp3_, &_tmp4_, 0);
	iter = _tmp4_;
	while (TRUE) {
		GtkTextIter _tmp5_ = {0};
		GtkTextIter _tmp6_ = {0};
		gboolean _tmp7_ = FALSE;
		GtkTextIter _tmp8_ = {0};
		GtkTextTag* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		GtkTextIter _tmp11_ = {0};
		gboolean _tmp12_ = FALSE;
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		_tmp7_ = gtk_text_iter_forward_search (&iter, "http://", GTK_TEXT_SEARCH_TEXT_ONLY, &_tmp5_, &_tmp6_, NULL);
		start = _tmp5_;
		end = _tmp6_;
		if (!_tmp7_) {
			break;
		}
		_tmp8_ = end;
		iter = _tmp8_;
		_tmp9_ = self->priv->tag_link;
		_tmp10_ = gtk_text_iter_begins_tag (&start, _tmp9_);
		if (_tmp10_) {
			continue;
		}
		_tmp12_ = gtk_text_iter_forward_search (&iter, " ", GTK_TEXT_SEARCH_TEXT_ONLY, &_tmp11_, NULL, NULL);
		end = _tmp11_;
		if (!_tmp12_) {
			GtkTextIter _tmp13_ = {0};
			gboolean _tmp14_ = FALSE;
			_tmp14_ = gtk_text_iter_forward_search (&iter, "\n", GTK_TEXT_SEARCH_TEXT_ONLY, &_tmp13_, NULL, NULL);
			end = _tmp13_;
			if (!_tmp14_) {
				GtkTextBuffer* _tmp15_ = NULL;
				GtkTextBuffer* _tmp16_ = NULL;
				GtkTextIter _tmp17_ = {0};
				_tmp15_ = gtk_text_view_get_buffer ((GtkTextView*) self);
				_tmp16_ = _tmp15_;
				gtk_text_buffer_get_iter_at_offset (_tmp16_, &_tmp17_, -1);
				end = _tmp17_;
			}
		} else {
			GtkTextIter _tmp18_ = {0};
			gboolean _tmp19_ = FALSE;
			_tmp19_ = gtk_text_iter_forward_search (&iter, "\n", GTK_TEXT_SEARCH_TEXT_ONLY, &_tmp18_, NULL, NULL);
			tmp = _tmp18_;
			if (_tmp19_) {
				gint _tmp20_ = 0;
				gint _tmp21_ = 0;
				_tmp20_ = gtk_text_iter_get_offset (&tmp);
				_tmp21_ = gtk_text_iter_get_offset (&end);
				if (_tmp20_ < _tmp21_) {
					GtkTextIter _tmp22_ = {0};
					_tmp22_ = tmp;
					end = _tmp22_;
				}
			}
		}
		_tmp23_ = gtk_text_iter_get_offset (&end);
		_tmp24_ = gtk_text_iter_get_offset (&start);
		if ((_tmp23_ - _tmp24_) >= 7) {
			GtkTextBuffer* _tmp25_ = NULL;
			GtkTextBuffer* _tmp26_ = NULL;
			GtkTextTag* _tmp27_ = NULL;
			GtkTextIter _tmp28_ = {0};
			GtkTextIter _tmp29_ = {0};
			_tmp25_ = gtk_text_view_get_buffer ((GtkTextView*) self);
			_tmp26_ = _tmp25_;
			_tmp27_ = self->priv->tag_link;
			_tmp28_ = start;
			_tmp29_ = end;
			gtk_text_buffer_apply_tag (_tmp26_, _tmp27_, &_tmp28_, &_tmp29_);
		}
	}
}


const gchar* xnp_hypertext_view_get_font (XnpHypertextView* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_font;
	result = _tmp0_;
	return result;
}


static void _vala_PangoFontDescription_free (PangoFontDescription* self) {
	g_boxed_free (pango_font_description_get_type (), self);
}


void xnp_hypertext_view_set_font (XnpHypertextView* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	PangoFontDescription* font_descr = NULL;
	const gchar* _tmp2_ = NULL;
	PangoFontDescription* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_font);
	self->priv->_font = _tmp1_;
	_tmp2_ = value;
	_tmp3_ = pango_font_description_from_string (_tmp2_);
	font_descr = _tmp3_;
	gtk_widget_modify_font ((GtkWidget*) self, font_descr);
	__vala_PangoFontDescription_free0 (font_descr);
	g_object_notify ((GObject *) self, "font");
}


static void _vala_PangoTabArray_free (PangoTabArray* self) {
	g_boxed_free (pango_tab_array_get_type (), self);
}


static GObject * xnp_hypertext_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	XnpHypertextView * self;
	PangoTabArray* _tmp0_ = NULL;
	PangoTabArray* _tmp1_ = NULL;
	parent_class = G_OBJECT_CLASS (xnp_hypertext_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
	xnp_hypertext_view_set_font (self, "Sans 13");
	_tmp0_ = pango_tab_array_new_with_positions (1, TRUE, PANGO_TAB_LEFT, 12, NULL);
	_tmp1_ = _tmp0_;
	gtk_text_view_set_tabs ((GtkTextView*) self, _tmp1_);
	__vala_PangoTabArray_free0 (_tmp1_);
	return obj;
}


static void xnp_hypertext_view_class_init (XnpHypertextViewClass * klass) {
	xnp_hypertext_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnpHypertextViewPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_xnp_hypertext_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_xnp_hypertext_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = xnp_hypertext_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = xnp_hypertext_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNP_HYPERTEXT_VIEW_FONT, g_param_spec_string ("font", "font", "font", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void xnp_hypertext_view_instance_init (XnpHypertextView * self) {
	GdkCursor* _tmp0_ = NULL;
	GdkCursor* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	self->priv = XNP_HYPERTEXT_VIEW_GET_PRIVATE (self);
	_tmp0_ = gdk_cursor_new (GDK_HAND2);
	self->priv->hand_cursor = _tmp0_;
	_tmp1_ = gdk_cursor_new (GDK_XTERM);
	self->priv->regular_cursor = _tmp1_;
	self->priv->cursor_over_link = FALSE;
	self->priv->undo_timeout = (guint) 0;
	_tmp2_ = g_strdup ("");
	self->priv->undo_text = _tmp2_;
	_tmp3_ = g_strdup ("");
	self->priv->redo_text = _tmp3_;
	self->priv->tag_timeout = (guint) 0;
}


static void xnp_hypertext_view_finalize (GObject* obj) {
	XnpHypertextView * self;
	guint _tmp0_ = 0U;
	guint _tmp2_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
	_tmp0_ = self->priv->undo_timeout;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->undo_timeout;
		g_source_remove (_tmp1_);
	}
	_tmp2_ = self->priv->tag_timeout;
	if (_tmp2_ != ((guint) 0)) {
		guint _tmp3_ = 0U;
		_tmp3_ = self->priv->tag_timeout;
		g_source_remove (_tmp3_);
	}
	_gdk_cursor_unref0 (self->priv->hand_cursor);
	_gdk_cursor_unref0 (self->priv->regular_cursor);
	_g_free0 (self->priv->undo_text);
	_g_free0 (self->priv->redo_text);
	_g_object_unref0 (self->priv->tag_link);
	_g_free0 (self->priv->_font);
	G_OBJECT_CLASS (xnp_hypertext_view_parent_class)->finalize (obj);
}


GType xnp_hypertext_view_get_type (void) {
	static volatile gsize xnp_hypertext_view_type_id__volatile = 0;
	if (g_once_init_enter (&xnp_hypertext_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (XnpHypertextViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnp_hypertext_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnpHypertextView), 0, (GInstanceInitFunc) xnp_hypertext_view_instance_init, NULL };
		GType xnp_hypertext_view_type_id;
		xnp_hypertext_view_type_id = g_type_register_static (GTK_TYPE_TEXT_VIEW, "XnpHypertextView", &g_define_type_info, 0);
		g_once_init_leave (&xnp_hypertext_view_type_id__volatile, xnp_hypertext_view_type_id);
	}
	return xnp_hypertext_view_type_id__volatile;
}


static void _vala_xnp_hypertext_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnpHypertextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
	switch (property_id) {
		case XNP_HYPERTEXT_VIEW_FONT:
		g_value_set_string (value, xnp_hypertext_view_get_font (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_xnp_hypertext_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnpHypertextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNP_TYPE_HYPERTEXT_VIEW, XnpHypertextView);
	switch (property_id) {
		case XNP_HYPERTEXT_VIEW_FONT:
		xnp_hypertext_view_set_font (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



